package gg.malloc.defense.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.ChatColor;
import net.md_5.bungee.api.chat.ComponentBuilder;

import gg.malloc.defense.model.Instance;

import gg.malloc.defense.Plugin;

public class ListGamesCommand implements CommandExecutor {
  Plugin m_plugin;

  public ListGamesCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    sender.sendMessage("Available games:");
    for(String arenaName : m_plugin.arenaNames()) {
      String stageName = "Ready to play";
      ChatColor stageColor = ChatColor.WHITE;
      if (m_plugin.hasRunnerForArenaName(arenaName)) {
        Instance runner = m_plugin.getRunnerForArenaName(arenaName);
        switch(runner.getStage()) {
          case Idle: stageColor = ChatColor.WHITE;stageName = "Open";break;
          case Warmup: stageColor = ChatColor.YELLOW;stageName = "" + runner.getPlayers().size() + " players warming up";break;
          case Countdown: stageColor = ChatColor.YELLOW;stageName = "" + runner.getPlayers().size() + " players warming up";break;
          case Playing: stageColor = ChatColor.GOLD;stageName = "" + runner.getPlayers().size() + " players";break;
          case GameOver: stageColor = ChatColor.RED;stageName = "Cleaning up...";break;
        }
      }


      BaseComponent[] message = new ComponentBuilder()
        .append(" " + arenaName).color(ChatColor.LIGHT_PURPLE).bold(true)
        .append(" - ").color(ChatColor.WHITE)
        .append(stageName).color(stageColor).italic(true)
        .append(" [Join] ").color(ChatColor.GOLD).bold(true)
        .event(new ClickEvent(ClickEvent.Action.RUN_COMMAND, "/malloc-defense:join " + arenaName))
        .create();
        sender.spigot().sendMessage(message);
    }
    return true;
  }
}

