package gg.malloc.defense.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import gg.malloc.defense.model.Instance;

import gg.malloc.defense.Plugin;

public class PlayerReadyCommand implements CommandExecutor {
  Plugin m_plugin;

  public PlayerReadyCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    if (sender instanceof Player) {
      Player player = (Player)sender;
      Instance runner = m_plugin.getRunnerForPlayer(player);
      if (runner != null) {
        runner.togglePlayerReady(player);
      } else {
        sender.sendMessage("You are not part of any game.");
      }
      return true;
    } else {
      sender.sendMessage("You must be a player to use this command.");
      return false;
    }
  }
}

